<template>
  <div class="sw-gs-layer-product-card-wrapper" @click="$emit('click', $event.target.value)">
    <SfProductCard
      :title="name"
      :link="''"
      :image="imageUrl"
      :special-price="formatPrice(specialPrice)"
      :regular-price="formatPrice(regularPrice)"
      :image-width="180"
      :image-height="200"
      class="sw-gs-layer-product-card"
      :wishlistIcon="false"
    >
      <template
        #image="{ image, title, imageHeight, imageWidth}"
      >
        <template v-if="Array.isArray(image)">
          <SwImage
            v-for="(picture, key) in image.slice(0, 2)"
            :key="key"
            class="sf-product-card__picture"
            :src="picture"
            :alt="title"
            :width="imageWidth"
            :height="imageHeight"
          />
        </template>
        <SwImage
          v-else
          class="sf-product-card__image"
          :src="image"
          :alt="title"
          :width="imageWidth"
          :height="imageHeight"
        />

        <SwGsLayerProductActions
          v-if="actions"
          :product="product"
          :overlay="true"
          :additionalInfos="true"
        />
      </template>

      <template #price="{ specialPrice, regularPrice }">
        <div class="sw-gs-layer-product-card-price-wrapper">
          <div v-if="number" class="sw-gs-layer-product-card-badge-wrapper">
            <SfBadge class="sf-badge--number color-light">
              {{ number }}
            </SfBadge>
          </div>

          <SfPrice
            v-if="regularPrice"
            class="sf-product-card__price"
            :regular="regularPrice"
            :special="specialPrice"
          />
        </div>
      </template>
    </SfProductCard>
  </div>
</template>

<script lang="ts">
  import { SfProductCard, SfBadge, SfPrice } from "@storefront-ui/vue"
  import {
    getProductThumbnailUrl,
    getProductTierPrices,
    getProductName,
    getProductCalculatedPrice,
    getProductCalculatedListingPrice,
    getProductPriceDiscount,
  } from "@shopware-pwa/helpers"
  import getResizedImage from "@/helpers/images/getResizedImage.js";
  import {toRefs, computed} from "@vue/composition-api";
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";
  import SwImage from "@/components/atoms/SwImage.vue";
  import SwGsLayerProductActions from "./SwGsLayerProductActions.vue";

  export default {
    name: "SwGsLayerProductCard",
    components: {
      SfProductCard,
      SfBadge,
      SfPrice,
      SwImage,
      SwGsLayerProductActions
    },
    setup(props, {}) {
      const { product } = toRefs(props);
      const { formatPrice } = usePriceFilter();

      const name = computed(() =>
        getProductName({product: product.value})
      )

      const imageUrl = computed(() =>
        getResizedImage(getProductThumbnailUrl(product.value), {
          width: 180,
          height: 200,
          quality: 100
        })
      )

      const tierPrices = computed(() =>
        getProductTierPrices(product.value)
      )

      const specialPrice = computed(() =>
        tierPrices.value.length
          ? undefined
          : getProductPriceDiscount(product.value) &&
          getProductCalculatedPrice(product.value)
      )

      const regularPrice = computed(() =>
        (tierPrices.value.length &&
          tierPrices.value[0] &&
          tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(product.value)
      )

      return {
        name,
        imageUrl,
        tierPrices,
        specialPrice,
        regularPrice,
        formatPrice
      }
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
      number: {
        type: Number,
        default: null,
      },
      actions: {
        type: Boolean,
        default: true,
      }
    }
  }
</script>

<style lang="scss" scoped>
  .sw-gs-layer-product-card {
    width: 100%;
    padding: var(--spacer-xs);

    ::v-deep .sw-gs-layer-product-actions {
      display: none;
    }

    &:hover {
      ::v-deep .sw-gs-layer-product-actions {
        display: flex;
      }
    }
  }

  .sw-gs-layer-product-card-price-wrapper {
    display: flex;
    justify-content: space-between;
  }

  .sw-gs-layer-product-card-badge-wrapper {
    ::v-deep .sf-badge {
      color: var(--c-gray);
    }
  }

  ::v-deep {
    .sf-product-card__image-wrapper {
      overflow: hidden;
    }

    // height is needed for collapse to work properly
    .sf-image--wrapper {
      display: block;
      height: 200px;
    }

    .sf-image {
      max-height: 100%;
    }

    .sf-product-card__link {
      cursor: auto;
    }

    .sf-product-card__title {
      margin-top: var(--spacer-xs);
    }

    .sf-product-card__price {
      margin-top: var(--spacer-2xs);
    }

    .sf-product-card__title,
    .sf-price__regular,
    .sf-price__special  {
      font-size: var(--font-size--sm);
    }
  }
</style>
